
/*
 * @(#)ClientEvent.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data Client Event class.
 *
 * @version     0.82 3 October 1996
 * @author      Rich Burridge
 */

public class
ClientEvent extends SharedDataEvent {

    /* The various types of event. */
    public static final int SESSION_INVITE = 0;
    public static final int SESSION_EXPEL  = 1;
    public static final int CHANNEL_INVITE = 2;
    public static final int CHANNEL_EXPEL  = 3;
    public static final int TOKEN_INVITE   = 4;
    public static final int TOKEN_EXPEL    = 5;

    protected String resourceName;


/**
 * <A NAME="SD_CLIENTEVENT"></A>
 * <EM>ClientEvent</EM> the constructor for the ClientEvent class.
 * A new client event is generated for a specific client when there has been
 * a change in the clients status (when it's been invited to join, or expelled
 * from a session/channel/token).
 *
 * @param <EM>resourceName</EM> the name of the session/channel/token. 
 * @param <EM>type</EM> the type of event.
 */

    public
    ClientEvent(String resourceName, int type) {
        if (ClientEvent_Debug) {
            System.out.println("ClientEvent: constructor:"       +
			       " resource name: " + resourceName +
			       " type: "          + type);
        }

        this.resourceName = resourceName;
	this.type         = type;
    }


/**
 * <A NAME="SD_GETRESOURCENAME"></A>
 * <EM>getResourceName</EM> get the name of the resource for this event.
 *
 * @return the name of the resource for this event.
 */
 
    public String
    getResourceName() {
        if (ClientEvent_Debug) {
            System.out.println("ClientEvent: getResourceName: " + resourceName); 
        }
        return(resourceName);
    }
}
