
/*
 * @(#)SharedDataEvent.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data SharedDataEvent class.
 *
 * @version     0.89 28 January 1997
 * @author      Rich Burridge
 */

public abstract class
SharedDataEvent extends SharedDataObject {

    /* The various types of generic event. */
    public static final int JOIN   = 0;
    public static final int LEAVE  = 1;

    protected Session session;
    protected String  clientName;
    protected int     type;


/**
 * <A NAME="SD_GETSESSION"></A>
 * <EM>getSession</EM> get the session for this event.
 *
 * @return the session for this event.
 */

    public Session
    getSession() {
        if (SharedDataEvent_Debug) {
            System.out.println("SharedDataEvent: getSession: " + session);
        }

        return(session);
    }


/**
 * <A NAME="SD_GETCLIENTNAME"></A>
 * <EM>getClientName</EM> get the name of the client for this event.
 *
 * @return the name of the client for this event.
 */

    public String
    getClientName() {
        if (SharedDataEvent_Debug) {
            System.out.println("SharedDataEvent: getClientName: " + clientName);
        }

        return(clientName);
    }


/**
 * <A NAME="SD_GETTYPE"></A>
 * <EM>getType</EM> get the type of this event.
 *
 * @return the type of this event.
 */

    public int
    getType() {
        if (SharedDataEvent_Debug) {
            System.out.println("SharedDataEvent: getType: " + type);
        }

        return(type);
    }
}
