
/*
 * @(#)ClientMessage.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer;

/**
 * Shared Data client message thread class.
 *
 * @version     0.89 27 January 1997
 * @author      Rich Burridge
 */

class
ClientMessage extends SharedDataMessage implements Runnable {

    /** The client to be notified. */
    private Client client;

    /** The name of the object in the client event. */
    private String objectName;

    /** The client event type. */
    private int eventType;


/**
 * <A NAME="SD_CLIENTMESSAGE"></A>
 * <EM>ClientMessage</EM>
 *
 * @param <EM>client</EM>
 * @param <EM>objectName</EM>
 * @param <EM>eventType</EM>
 */

    public
    ClientMessage(Client client, String objectName, int eventType) {
        if (ClientMessage_Debug) {
            System.out.println("ClientMessage: constructor:" +
                               " client: "      + client +
			       " object name: " + objectName +
			       " event type: "  + eventType);
        }
 
        this.client     = client;
	this.objectName = objectName;
	this.eventType  = eventType;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>tok</EM>
 */

    protected void
    handleMessage(StringTokenizer tok) {
        if (ClientMessage_Debug) {
            System.out.println("ClientMessage: handleMessage.");
        }

        client.clientChanged(new ClientEvent(objectName, eventType));
    }


/**
 * <A NAME="SD_RUN"></A>
 * <EM>run</EM>
 */

    public void
    run() {
	if (ClientMessage_Debug) {
            System.out.println("ClientMessage: run.");
        }
 
        handleMessage(null);
    }
}
