
/*
 * @(#)ConsumerMessage.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.util.StringTokenizer;

/**
 * Shared Data channel consumer message thread class.
 *
 * @version     0.89 27 January 1997
 * @author      Rich Burridge
 */

class
ConsumerMessage extends SharedDataMessage implements Runnable {

    /** The channel consumer to be notified. */
    private ChannelConsumer consumer;

    /** The data to be sent to the consumer. */
    private Data data;


/**
 * <A NAME="SD_CONSUMERMESSAGE"></A>
 * <EM>ConsumerMessage</EM>
 *
 * @param <EM>consumer</EM>
 * @param <EM>data</EM>
 */

    public
    ConsumerMessage(ChannelConsumer consumer, Data data) {
        if (ConsumerMessage_Debug) {
            System.out.println("ConsumerMessage: constructor:" +
                               " consumer: " + consumer +
			       " data: "     + data);
        }
 
        this.consumer = consumer;
	this.data     = data;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>tok</EM>
 */

    protected void
    handleMessage(StringTokenizer tok) {
        if (ConsumerMessage_Debug) {
            System.out.println("ConsumerMessage: handleMessage.");
        }

        consumer.dataReceived(data);
    }


/**
 * <A NAME="SD_RUN"></A>
 * <EM>run</EM>
 */

    public void
    run() {
        if (ConsumerMessage_Debug) {
            System.out.println("ConsumerMessage: run.");
        }

        handleMessage(null);
    }
}
