
/*
 * @(#)RegistryServerThread.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import java.net.Socket;
import java.util.StringTokenizer;

/**
 * Shared Data Registry Server Thread class.
 *
 * @version     0.84 24 October 1996
 * @author      Rich Burridge
 */
 
class
RegistryServerThread extends TCPSocketThread {
 
    /** Handle to server-side registry object. */
    private Registry registry;


/**
 * <A NAME="SD_REGISTRYSERVERTHREAD"></A>
 * <EM>RegistryServerThread</EM>
 *
 * @param <EM>socket</EM>
 * @param <EM>registry</EM>
 */

    public
    RegistryServerThread(Socket socket, Registry registry) {
        super(socket);

	if (RegistryServerThread_Debug) {
            System.out.println("RegistryServerThread: constructor:" +
			       " socket: "   + socket +
			       " registry: " + registry);
        }

	this.registry = registry;
    }    


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>message</EM>
 */

    protected void
    handleMessage(String message) {
        StringTokenizer tok = new StringTokenizer(message, T_Sep, false);
	RegistryServerMessage rsm = new RegistryServerMessage(registry, this);

        if (RegistryServerThread_Debug) {
            System.out.println("RegistryServerThread: handleMessage:" +
                               " message: " + message);
        }
 
        rsm.handleMessage(tok);
    }
}
