
/*
 * @(#)SharedDataManagerImpl.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

/**
 * Shared Data Manager implementation.
 *
 * @version     0.90 5 February 1997
 * @author      Rich Burridge
 */

class
SharedDataManagerImpl extends socketSharedDataObject
		      implements SharedData.SharedDataManager {

    /** The name of this manager. */
    protected String name;


/**
 * <A NAME="SD_SHAREDDATAMANAGERIMPL"></A>
 * <EM>SharedDataManagerImpl</EM> the constructor for the
 * SharedDataManagerImpl class.
 *
 * @param <EM>name</EM> the name of the manager being constructed.
 * The manager name cannot include '\u0001' or newline characters. 
 */

    public
    SharedDataManagerImpl(String name) {
        if (SharedDataManagerImpl_Debug) {
            System.out.println("SharedDataManagerImpl: constructor: " + name);
        }

        this.name = name;
    }


/**
 * <A NAME="SD_GETNAME"></A>
 * <EM>getName</EM> get the name of this manager.
 *
 * @return the name of the manager.
 * The manager name cannot include '\u0001' or newline characters. 
 */
 
    public String
    getName() {
        if (SharedDataManagerImpl_Debug) {
            System.out.println("SharedDataManagerImpl: getName: " + name);
        }
        return(name);
    }
}
