
/*
 * @(#)SocketServer.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

import SharedData.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;

/**
 * Shared Data Socket Server class.
 *
 * @version     0.89 27 January 1997
 * @author      Rich Burridge
 */

class
SocketServer extends socketSharedDataObject implements Runnable {

    /** The port number used by this socket server. */
    protected int port;

    /** The Server-side object associated with this socket. */
    protected static Object object;


/**
 * <A NAME="SD_GETPORT"></A>
 * <EM>getPort</EM> return the port number being used by this socket server.
 *
 * @return server socket port number
 */

    int
    getPort() {
        if (SocketServer_Debug) {
            System.out.println("SocketServer: getPort.");
        }

        return(port);
    }


/**
 * <A NAME="SD_RUN"></A>
 * <EM>run</EM>
 */

    public void
    run() {
        if (SocketServer_Debug) {
            System.out.println("SocketServer: run.");
        }

        System.out.println("SocketServer: run: " +
                           "Should be over-ridden by it's subclass.");
    }
}
