// -*- java -*-
// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED `AS IS' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: GEF.java
// Classes: GEF
// Original Author: jrobbins@ics.uci.edu
// $Id: GEF.m4,v 1.3 1997/06/10 23:42:51 jrobbins Exp $



package uci.graphedit;

/** This class defines many constants that are used throughout the
 *  framework. Also, it extends "marker interfaces" needed in Java 1.1
 *  for serialization, and possibly other system-wide features.
 *
 * This version is for JDK 1.0.2. */

public interface GEF extends uci.util.SERIALIZABLE {

  public static final String pLOCKED = "Locked";
  public static final String pBBOX = "Bbox";

  public static final String pLINE_COLOR = "LineColor";
  public static final String pLINE_WIDTH = "LineWidth";
  public static final String pFILL_COLOR = "FillColor";
  public static final String pFILLED = "Filled";
  public static final String pSHADOW_COLOR = "ShadowColor";
  public static final String pSHADOW_OFFSET = "ShadowOffset";

  public static final String pRECTILINEAR = "Rectilinear";
  public static final String pNUM_POINTS = "NumPoints";

  public static final String pCORNER_RADIUS = "CornerRadius";

  public static final String pTEXT = "Text";
  public static final String pTEXT_COLOR = "TextColor";
  public static final String pTEXT_FILL_COLOR = "TextFillColor";
  public static final String pTEXT_FILLED = "TextFilled";
  public static final String pFONT_NAME = "FontName";
  public static final String pFONT_SIZE = "Size";
  public static final String pALIGNMENT = "Alignment";

  public static final String pLINE_SPACING = "LineSpacing";
  public static final String pTOP_MARGIN = "TopMargin";
  public static final String pBOT_MARGIN = "BottomMargin";
  public static final String pLEFT_MARGIN = "LeftMargin";
  public static final String pRIGHT_MARGIN = "RightMargin";
  public static final String pEXPAND_ONLY = "ExpandOnly";

  public static final String pBOLD = "Bold";
  public static final String pITALIC = "Italic";
  public static final String pSTRIKE = "StrikeThrough";
  public static final String pUNDERLINE = "Underline";
  public static final String pTEXT_SHADOW = "TextShadow";
  public static final String pTEXT_SHADOW_COLOR = "TextShadowColor";

} /* end interface GEF */
