// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: PackageGraphEdit.java
// Classes: PackageGraphEdit
// Original Author: jrobbins@ics.uci.edu
// $Id: PackageGraphEdit.java,v 1.13 1997/06/10 23:43:19 jrobbins Exp $

package uci.graphedit;

import uci.util.*;

/** Instances of this class describe the classes that make up the java
 *  package uci.graphedit. This list of class names is used by the
 *  preloader to show progress in downloading the .class files under
 *  browsers that do not support the ARCHIVE tag (e.g., Internet
 *  Explorer 3.0).
 *
 * @see uci.util.Preloader */

public class PackageGraphEdit extends Package {

  public PackageGraphEdit() {
    super("uci.graphedit");
    add("Action");
    add("ActionAdjustGrid");
    add("ActionAdjustGuide");
    add("ActionAdjustPageBreaks");
    add("ActionAlign");
    add("ActionCreateNode");
    add("ActionDelete");
    add("ActionDispose");
    add("ActionEditNode");
    add("ActionGroup");
    add("ActionInsertVertex");
    add("ActionLoad");
    add("ActionNudge");
    add("ActionOpenWindow");
    add("ActionPrint");
    add("ActionQuit");
    add("ActionRemoveVertex");
    add("ActionReorder");
    add("ActionSave");
    add("ActionScroll");
    add("ActionSelectNext");
    add("ActionSetAttr");
    add("ActionSetMode");
    add("ActionShowURL");
    add("ActionUngroup");
    add("ActionQuit");
    
    add("ActiveButton");
    add("ActiveChoice");
    add("ActiveComponent");
    add("ActiveMenu");

    add("ArcPerspective");
    add("ArcPerzLine");
    add("ArcPerzRectiline");

    add("Compat");

    add("DiagramElement");

    add("Editor");
    add("EditorFrame");
    add("EditorMenus");
    add("ExecuteActionWindow");

    add("Fig");
    add("FigCircle");
    add("FigImage");
    add("FigInk");
    add("FigLine");
    add("FigList");
    add("FigPoly");
    add("FigRRect");
    add("FigRect");
    add("FigText");

    add("ForwardingComponent");
    add("ForwardingFrame");
    add("ForwardingPanel");

    add("Geometry");

    add("Globals");

    add("Guide");
    add("GuideGrid");

    add("Handle");

    add("Layer");
    add("LayerComposite");
    add("LayerDiagram");
    add("LayerGrid");
    add("LayerPageBreaks");

    add("Mode");
    add("ModeCreate");
    add("ModeCreateArc");
    add("ModeCreateFigCircle");
    add("ModeCreateFigImage");
    add("ModeCreateFigInk");
    add("ModeCreateFigLine");
    add("ModeCreateFigPoly");
    add("ModeCreateFigRRect");
    add("ModeCreateFigRect");
    add("ModeCreateFigText");
    add("ModeExampleKeys");
    add("ModeModify");
    add("ModePlace");
    add("ModeSelect");
    add("ModeStack");

    add("NetArc");
    add("NetList");
    add("NetNode");
    add("NetPort");
    add("NetPrimitive");

    add("Palette");
    add("PaletteAttr");
    add("PaletteCompound");
    add("PaletteDecorator");
    add("PaletteFig");
    add("PaletteSticky");
    add("PaletteTop");
    add("Perspective");

    add("Prefs");
    add("PrefsEditor");

    add("RedrawManager");

    add("Selection");
    add("SelectionBox");
    add("SelectionHandles");
    add("SelectionMultiple");
    add("SelectionSingle");
//    add("ActionNull");
//    add("ActionSequence");
//    add("LayerPolar");
  }

} /* end class PackageGraphEdit */
