// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: NodeWall.java
// Classes: NodeWall
// Original Author: ics125b spring 1996
// $Id: NodeWall.java,v 1.4 1997/06/10 23:40:32 jrobbins Exp $

package uci.graphedit.demo;

import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/** An example subclass of NetNode for use in the Example application.
 *
 * @see Example */
public class NodeWall extends SampleNode {

   /** Initialize a new NodeWall from the given default node and
    *  application specific model. <p>
    *
    *  Needs-More-Work: for now we construct the Perspective
    *  programatically, but eventually we will store it in a class
    *  variable and just refer to it, or copy it(?). That way the user
    *  can edit the Perspective(s) stored in the class variable and
    *  have those changes shown for all existing nodes, or for all
    *  future nodes. Maybe I should think about doing virtual
    *  copies?<p> */

  public void initialize(NetNode deft, Object model) {
      portList = new NetPort[2];
      portList[0] = new PortPower(this, PortPower.SOCKET);
      portList[1] = new PortPower(this, PortPower.SOCKET);
   }

  public Perspective makePerspective(Layer lay) {
    Fig obj1 = new FigRect(0, 0, 200, 10, Color.black, Color.white);
    Fig obj2 = new FigRect( 3, 3, 14, 14, Color.black, Color.blue);
    Fig obj3 = new FigRect( 25, 3, 14, 14, Color.black, Color.blue);
    FigList temp_list = new FigList();
    temp_list.addFig(obj1);
    temp_list.addFig(obj2);
    temp_list.addFig(obj3);
    Perspective pers1 = new Perspective(this, temp_list);
    pers1.addPort(portList[0], obj2);
    pers1.addPort(portList[1], obj3);
    return pers1;
  }

} /* end class NodeWall */
