package uci.ui;

import java.awt.*;
import java.util.*;
import uci.graphedit.DiagramElement;

/** <A HREF="../features.html#property_sheet_editors">
 *  <TT>FEATURE: property_sheet_editors</TT></A>
 */

public class PropEditor extends Panel implements Observer {
    ////////////////////////////////////////////////////////////////
    // instance variables

    public IProps _sel = null;
    public Hashtable _pendingStores = new Hashtable();
    public boolean _autoApply = true;
    public String _tabName = "Misc";

    ////////////////////////////////////////////////////////////////
    // constructors

    public PropEditor() { }

    ////////////////////////////////////////////////////////////////
    // accessors

    public void setSelection(IProps s) {
      if (_sel == s) return;
      if (_sel instanceof Observable)
          ((Observable)_sel).deleteObserver(this);
      _sel = s;
      if (_sel instanceof Observable)
          ((Observable)_sel).addObserver(this);
      updateComponents();
    }

    public void setAutoApply(boolean aa) {
      _autoApply = aa;
      if (_autoApply) apply();
    }

    public String getTabName() { return _tabName; }
    public void setTabName(String tn) { _tabName = tn; }

    public boolean canEdit(IProps item) { return true; }

    ////////////////////////////////////////////////////////////////
    // storing properties

    public void store(String key, Object value) {
      if (key == null || value == null) return;
      _pendingStores.put(key, value);
      if (_autoApply) apply();
    }

    public void apply() {
      if (_sel instanceof DiagramElement)
        ((DiagramElement)_sel).startTrans();
      if (_sel != null) _sel.put(_pendingStores);
      if (_sel instanceof DiagramElement)
        ((DiagramElement)_sel).endTrans();
      _pendingStores.clear();
    }

    public void revert() {
      _pendingStores.clear();
      updateComponents();
    }

    ////////////////////////////////////////////////////////////////
    // notifications and updates

    public void updateComponents() { }

    public void updateComponent(String key) { updateComponents(); }

    public void update(Observable obs, Object arg) {
        if (obs == _sel && arg instanceof String)
          updateComponent((String)arg);
    }

} /* end class PropEditor */
