// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: DebugLog.java
// Class: DebugLog
// Original Author: jrobbins@ics.uci.edu
// $Id: DebugLog.java,v 1.6 1997/06/10 23:30:56 jrobbins Exp $

package uci.util;

/** This is a useful utility for debugging. In various places in the
 *  framework there are calls to DebugLog.log(). If the proper -D
 *  defines are supplied when running the application those debugging
 *  statements will be enabled or disabled. */

public class DebugLog {

  /** Print the given message if the guard was defined with a command
   *  line -D option. */
  public static final void log(String guard, String msg) { 
    if (Boolean.getBoolean(guard)) System.out.println(msg);
  }

  /** Print the given message if the guard was defined with a command
   *  line -D option and the given condition evaluates to true. */
  public static final void log(String guard, boolean cond, String msg) {
    if (Boolean.getBoolean(guard) && cond) System.out.println(msg);
  }

} /* end class DebugLog */
