// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: Functor.java
// Interfaces: Functor
// Original Author: jrobbins@ics.uci.edu
// $Id: Functor.java,v 1.2 1997/06/10 23:31:22 jrobbins Exp $

package uci.util;

import java.util.*;

/** Interface to define Functor objects.  Functor's are described in
 *  many papers and books about design patterns or coding idioms.  They
 *  are basically functions, but implemented as instances of a class
 *  with only one method. That allows passing the Functor object
 *  around, whereas Java does not allow any operations on functions. */

public interface Functor extends UTIL  {
  public Object apply(Object x);
} /* end interface Functor */
