// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: SERIALIZABLE.java
// Classes: SERIALIZABLE
// Original Author: jrobbins@ics.uci.edu
// $Id: SERIALIZABLE.m4,v 1.1 1997/06/11 00:50:00 jrobbins Exp $

package uci.util;

changequote(<<,>>)

/** This interface is intended to make certain GEF classes implement
 *  interface java.io.Serializable when that interface is available
 *  in the development environment, and to not implement it when it is
 *  not available. For example, java.io.Serializable is not included
 *  under jdk1.0.2, because widely used classes like Vector and Hashtable
 *  are not serializable.
 *  <A HREF="../features.html#load_and_save">
 *  <TT>FEATURE: load_and_save</TT></A>
 *  <A HREF="../features.html#cross_development_environments">
 *  <TT>FEATURE: cross_development_environments</TT></A>
 */ 

public interface SERIALIZABLE
ifdef(<<jdk11>>,,//) extends java.io.Serializable
{

} /* end interface */
