
package webflow.backend.WFSession;

import java.net.*;
import java.io.*;
import java.util.*;

import webflow.backend.*;
import webflow.frontend.*;
import webflow.util.Action;


/**
*/
public class
ServiceDestroyModule extends SessionServices
                     implements webflow.util.Action, WebFlowDebugFlags
{
  /** Name of the Module */
  private  ID ModuleID;

  /**
  */
  public
  ServiceDestroyModule(ID _moduleID, WFlowSession _mySession)
  { 
     super(_mySession);
     ModuleID = _moduleID;
 
  }// end of constructor

  /**
  * 
  * <ol>
  *  <li> Accepts the connection request from client.
  *  <li> Sends the SMreply to the client and waits for the acknowledge. 
  *  <li> Stop.
  * </ol>
  */
  public void
  //run()
  service()
  { 
    clientSocket = null;

    /** Accept client connection */
    if(acceptConnection()<0) return;
    Diagnostic diag = mySession.getDiagnostic();

    SMreply rett = new SMreply(SMreply.ERROR,"Unknown");

    diag.write("destroy module requested");
    if(DEBUG==true)
      System.out.println(" module "+ModuleID+" is being destroyed !");

    try
    {  /** get the actual key, and retrieve its module representation */
       ModuleRepresentation mr = mySession.getModuleRepWithID(ModuleID);

       diag.write("retrieved a module");
       if(DEBUG==true) System.out.println("retrieved a module");

       /** open a socket towards the corresponding module manager  */
       Socket s = new Socket(mr.getHostName(),mr.getModuleManagerPort());

       diag.write("sending a request to destroy the module");
       if(DEBUG==true)
          System.out.println("sending a request to destroy the module");

       /** and send a request to destroy the module */
       MMrequest req = new MMrequest(MMrequest.DESTROY, ModuleID);
       req.toStream(s.getOutputStream());

       /** wait for a reply */
       MMreply reply = new MMreply();
       reply.fromStream(s.getInputStream());

       diag.write("received reply, status = " + reply.getStatus());
       if(DEBUG==true)
          System.out.println("received reply, status = " +
                              reply.getStatus());

       /** and if an error occured */
       if (reply.getStatus()== MMreply.ERROR)
            rett = new SMreply(SMreply.ERROR, reply.getDescription());
       else rett = new SMreply(SMreply.OK);

       Object res = mySession.removeModuleWithID(ModuleID);

       if(res==null) System.out.println(ModuleID+" can not be removed!");
       else if(DEBUG==true) System.out.println(ModuleID+" is removed");

       s.close();

    } /** in case an exception occurs, for now, just ignore the     */
      /** started modules, and send an 'error occured' message back */
      catch(IOException e1)
      {  rett = new SMreply(SMreply.ERROR,
             "Exception raised while trying to run");
      }
      catch(Exception e)
      {  diag.write("wierd exception raised");
         diag.write("Exception " + e);
         rett = new SMreply(SMreply.ERROR,
             "Exception raised while trying to run");
      }

    sendMessage( rett );


  }// end of run


}// end of class SessionServices

