
package webflow.backend.WFSession;

import java.net.*;
import java.io.*;
import webflow.backend.*;
import webflow.util.*;

/**
*/
public class
SessionServices extends Object
                implements webflow.util.Action, WebFlowDebugFlags 
{
  /** Session object related to this service */
  protected WFlowSession mySession = null;

  /** ServerSocket to send back the result */
  protected ServerSocket mySocket = null;

  /** Port Number of this socket */
  protected int portNumber = -1; 

  /** Client Socket */
  protected Socket clientSocket = null;

  /**
  */
  public
  SessionServices(WFlowSession _mySession)
  { 
     /** update Session object */
     mySession = _mySession;

     /** Open temporary ServerSocket */
     try
     {  
        mySocket = new ServerSocket(0);

        portNumber = mySocket.getLocalPort();

     } catch(IOException e)
       {  System.out.println(" IOException is raised "+e);
          e.printStackTrace();
       }
     
     if(DEBUG ==true)
        System.out.println("   I am listening at :"+portNumber);

  }// end of constructor

  /**
  */
  public int
  getPortNumber()
  {  return portNumber; }

  /**
  */
  public void
  sendMessage(SMreply _message)
  {
     if(clientSocket!=null )
     {
        try
        { 
           _message.toStream(clientSocket.getOutputStream());
           clientSocket.close();

        } catch(IOException ioe)
          {  System.out.println(" IOException is raised!"+ioe);
             ioe.printStackTrace();
             return;
          } 

     }// end of if

  }// ens of sendMessage() 

  /**
  */
  public void 
  destroy()
  { 
    try
    {  if(mySocket!=null) mySocket.close(); 
    } catch(IOException e)
       {  System.out.println(" IOException is raised "+e);
          e.printStackTrace();
       }

    if(DEBUG ==true)
       System.out.println(" SessionService Socket is closed!");

  }// end of destroy()

  /**
  */
  public int
  acceptConnection() 
  {
     int ret = 1;

     try
     {  clientSocket = mySocket.accept();
     } catch(IOException ioe)
       {  System.out.println(" IOException is raised!"+ioe);
          ioe.printStackTrace();
          ret = -1;
       }
    
     return ret;

  }// end of acceptConnection()

  /**
  */
  public void
  service() { }

}// end of class SessionServices

