package webflow.backend;
import java.io.*;
import java.net.*;
import java.util.*;

public  class recv_module {
  DataInputStream  dis;
  DataOutputStream dos;
  public boolean  FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public recv_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }

 public recv_module(DataOutputStream dos, DataInputStream dis, boolean FORT)
{
	this.dis= dis;
	this.dos= dos;
	FORTRAN_DEFINED= FORT;
}
   public int recv_int() throws IOException
  {
     return dis.readInt();
  }
 
  public char recv_char()  throws IOException
  {
    return (char)(dis.readInt());
  }
 
  public boolean recv_boolean()  throws IOException
  {
    int intval ;
 
    intval = dis.readInt();
    if (intval ==  0)
      return true;
    else
      return false;
  }
 
  public byte recv_byte()  throws IOException
  {
    return (byte)(dis.readInt());
  }
 
  public short recv_short()  throws IOException
  {
    return (short)(dis.readInt());
  }
 
  public long  recv_long()  throws IOException
  {
     return dis.readLong();
  }
 
  public float  recv_float()  throws IOException
  {
     return dis.readFloat();
  }
 
  public double  recv_double()  throws IOException
  {
     return dis.readDouble();
  }
 
  public byte recvByte() throws IOException
   {
     return dis.readByte();
   }

   public void flushSocket() throws IOException
   {
     dos.flush();
   }
   
   

// FOR INTEGER ARRAYS///////////////////////////////////////
//////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

 public void  recv_1Dint_array(int []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++){
        buf[i] = recv_int();
        System.out.println(buf[i]);
     }
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dint_array(int[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     // nelems = recv_int() ; // number of elements in array 
         
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_int();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_int();
     
  }     
 
  public void  recv_3Dint_array(int[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_int();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_int();
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
   public StringBuffer recv_String() throws IOException
   {
      byte val;
      int rem;

      int strLen = recv_int();
      System.out.println("strlen "+strLen);
      
      char [] charArray = new char[strLen];
      
      for(int i=0;i<strLen;i++)
         charArray[i] = (char)(recvByte());

      rem = 0;
      if ((strLen%4) != 0)
        rem = 4-strLen%4;
      // read padding zeros to make the total size multiple of 4
      for(int i=0; i <rem ; i++)
        recvByte();
      
      return new StringBuffer().append(charArray);
   }
   

   public void  recv_1Dchar_array(char[] str)
  throws IOException
  {  int nelems;   

     int strlen = str.length;

     for(int i=0; i<strlen;i++) 
         str[i] = recv_char();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dchar_array(char[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_char();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_char();
     
  }     
 
  public void  recv_3Dchar_array(char[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_char();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_char();
    
  }



  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dboolean_array(boolean []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_boolean();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_boolean();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_boolean();
     
  }     

   
  public void  recv_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_boolean();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_boolean();
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dbyte_array(byte []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_byte();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dbyte_array(byte[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_byte();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_byte();
     
  }     

   
  public void  recv_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_byte();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_byte();
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dshort_array(short []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_short();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dshort_array(short[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
      
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_short();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_short();
     
  }     
 
  public void  recv_3Dshort_array(short[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_short();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_short();
    
  }

 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  recv_1Dlong_array(long []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array        
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_long();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dlong_array(long[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_long();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_long();
     
  }     
 
  public void  recv_3Dlong_array(long[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_long();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_long();
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dfloat_array(float []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     // nelems = recv_int() ; // number of elements in array 
   
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_float();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dfloat_array(float[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_float();

     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_float();
     
  }     
 
  public void  recv_3Dfloat_array(float[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_float();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_float();
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Ddouble_array(double []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     System.out.println("recv_1Ddouble_array: ndims = "+dims[0]);
     for (int i=0;i<dims[0];i++){
        buf[i] = recv_double();
	System.out.println("Received double "+ buf[i]+ "index = "+i);
	
     }
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Ddouble_array(double[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     double l;
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
	       buf[i][j] = recv_double();
     /* if((i==1)&&(j==1)){
	    System.out.println("DATAAAAAA = " + recv_double());
	    }
	    else
	      l = recv_double();*/
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_double();
     /* System.out.println("DATAAAAAA = " + recv_double());*/
     System.out.println("OKAY RECEIVED DATA = " +buf[0][0]);
  }     
 
  public void  recv_3Ddouble_array(double[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_double();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_double();
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dobject_array(Object []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++)
        recv_structure(buf[i]);
  }


   public void  recv_2Dobject_array(Object [][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             recv_structure(buf[i][j]);  
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            recv_structure(buf[i][j]); 
     
  }     
 
  public void  recv_3Dobject_array(Object[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              recv_structure(buf[i][j][k]); 
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              recv_structure(buf[i][j][k]);
  }

  public void recv_structure(Object object) throws IOException
  {  
      java.lang.reflect.Field field[] ;


      field = object.getClass().getDeclaredFields();
            

      for(int i=0;i<field.length;i++){  
        String type = field[i].getType().getName();
        System.out.println("type  "+type);

        try{
          if (type.equals("boolean"))
             field[i].setBoolean(object,recv_boolean());
          else if (type.equals("byte"))
             field[i].setByte(object,recv_byte());
          else if (type.equals("char"))
             field[i].setChar(object,recv_char()); 
          else if (type.equals("short"))
             field[i].setShort(object,recv_short());  
          else if (type.equals("int"))
             field[i].setInt(object,recv_int());
          else if (type.equals("long"))
             field[i].setLong(object,recv_long());
          else if (type.equals("float"))
             field[i].setFloat(object,recv_float());
          else if (type.equals("double"))
             field[i].setDouble(object,recv_float());
         
        
          //boolean arrays 
          else if (type.equals("[Z"))
             recv_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             recv_2Dboolean_array((boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             recv_3Dboolean_array((boolean[][][])field[i].get(object));

          
           //byte arrays 
          else if (type.equals("[B"))
             recv_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             recv_2Dbyte_array((byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             recv_3Dbyte_array((byte[][][])field[i].get(object));

          //char arrays 
          else if (type.equals("[C"))
             recv_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             recv_2Dchar_array((char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             recv_3Dchar_array((char[][][])field[i].get(object));
 
          //short arrays 
          else if (type.equals("[S"))
             recv_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             recv_2Dshort_array((short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             recv_3Dshort_array((short[][][])field[i].get(object));
  
          //int arrays 
          else if (type.equals("[I"))
             recv_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             recv_2Dint_array((int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             recv_3Dint_array((int[][][])field[i].get(object));
 
          //long arrays 
          else if (type.equals("[J"))
             recv_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[J"))
             recv_2Dlong_array((long[][])field[i].get(object));
          else if (type.equals("[[[J"))
             recv_3Dlong_array((long[][][])field[i].get(object));
 
        
          //float arrays 
          else if (type.equals("[F"))
             recv_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             recv_2Dfloat_array((float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             recv_3Dfloat_array((float[][][])field[i].get(object));

          //double arrays 
          else if (type.equals("[D"))
             recv_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             recv_2Ddouble_array((double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             recv_3Ddouble_array((double[][][])field[i].get(object));
          else if(field[i].getDeclaringClass().isInstance(object)) 
             recv_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

         }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}   
  
 

