package webflow.backend;
import java.io.*;
import java.net.*;
import java.util.*;

public  class send_module {
 DataInputStream  dis;
  DataOutputStream dos;
  public boolean FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public  send_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }
 
	public send_module(DataOutputStream dos, DataInputStream din,boolean FORTRAN_DEFINED )
	{
		this.dis= dis;
		this.dos= dos;
		this.FORTRAN_DEFINED = FORTRAN_DEFINED;
}
  public void  send_int(int item) throws IOException
  {
      dos.writeInt(item);
  }

  public void  send_char(char ch)  throws IOException
  {
     dos.writeInt((int)ch);
  }
  

  public void  send_boolean(boolean vbool)  throws IOException
  {
    int intval ;

    if (vbool)
      intval = 1;
    else
      intval = 0;
    dos.writeInt(intval);
  }

  public void send_byte(byte vby)  throws IOException
  {
    dos.writeInt((int)vby);
  }

  public void  send_short(short vsho)  throws IOException
  {
    dos.writeInt((int)vsho);
  }

  public void   send_long(long vlong)  throws IOException
  {
      dos.writeLong(vlong);
  }

  public void  send_float(float vfloat)  throws IOException
  {
     dos.writeFloat(vfloat);
  }

  public void   send_double(double vdouble)  throws IOException
  {
      dos.writeDouble(vdouble);
  }

  public void  send_header(int[] dim,int ndims)  throws IOException
  {
     int nelems=1;
     for(int i=0;i<ndims;i++)
        nelems *= dim[i] ;
     send_int(nelems);    
  }

  // FOR INTEGER ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dint_array(int []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++)
        send_int(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dint_array(int[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_int(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_int(buf[i][j]);  
     
  }     
 
  public void  send_3Dint_array(int[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_int(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_int(buf[i][j][k]);  
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
   public void send_String(String str) throws IOException
   {  
      int rem;
      int len = str.length();
      char [] charArray = str.toCharArray();
      // send the total length of string 
	System.out.println("String = " + str);
	System.out.println("len = "+len);         
      send_int(len);
      for(int i = 0;i<len;i++)
        dos.writeByte((byte)(charArray[i]));

      rem = 0;
      if ((len%4) != 0)
        rem = 4-len%4;
      // write concanated zeros to make the size of string multiple of 4
      for(int i=0; i <rem; i++)
	dos.writeByte(0);
      
   }
   

   public void  send_1Dchar_array(char [] buf)
     throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_char(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dchar_array(char[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_char(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_char(buf[i][j]);  
     
  }     
 
  public void  send_3Dchar_array(char[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_char(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_char(buf[i][j][k]);  
    
  }

  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dboolean_array(boolean []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     
     for (int i=0;i<dims[0];i++)
        send_boolean(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_boolean(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_boolean(buf[i][j]);  
     
  }     

   
  public void  send_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_boolean(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_boolean(buf[i][j][k]);  
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dbyte_array(byte []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_byte(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dbyte_array(byte[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_byte(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_byte(buf[i][j]);  
     
  }     

   
  public void  send_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
    
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_byte(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_byte(buf[i][j][k]);  
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dshort_array(short []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_short(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dshort_array(short[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_short(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_short(buf[i][j]);  
     
  }     
 
  public void  send_3Dshort_array(short[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_short(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_short(buf[i][j][k]);  
    
  }



 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  send_1Dlong_array(long []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_long(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dlong_array(long[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_long(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_long(buf[i][j]);  
     
  }     
 
  public void  send_3Dlong_array(long[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_long(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_long(buf[i][j][k]);  
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dfloat_array(float []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_float(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dfloat_array(float[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_float(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_float(buf[i][j]);  
     
  }     
 
  public void  send_3Dfloat_array(float[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_float(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_float(buf[i][j][k]);  
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Ddouble_array(double []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_double(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Ddouble_array(double[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_double(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_double(buf[i][j]);  
     
  }     
 
  public void  send_3Ddouble_array(double[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_double(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_double(buf[i][j][k]);  
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dobject_array(Object []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_structure(buf[i]);
  
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dobject_array(Object[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_structure(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_structure(buf[i][j]);  
     
  }     
 
  public void  send_3Dobject_array(Object[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_structure(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_structure(buf[i][j][k]);  
    
  }


  public void send_structure(Object object) throws IOException
  {
      java.lang.reflect.Field field[] ;

      field = object.getClass().getDeclaredFields();
      
      for(int i=0;i<field.length;i++){
        String type = field[i].getType().getName();

        try{
          if (type.equals("boolean"))
             send_boolean(field[i].getBoolean(object)); 
          else if (type.equals("byte"))
             send_byte(field[i].getByte(object)); 
          else if (type.equals("char"))
             send_char(field[i].getChar(object));  
          else if (type.equals("short"))
             send_short(field[i].getShort(object)); 
          else if (type.equals("int"))
             send_int(field[i].getInt(object)); 
          else if (type.equals("long"))
             send_long(field[i].getLong(object)); 
          else if (type.equals("float"))
             send_float(field[i].getFloat(object));   
          else if (type.equals("double"))
             send_double(field[i].getDouble(object)); 

          //boolean arrays 
          else if (type.equals("[Z"))
             send_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             send_2Dboolean_array( (boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             send_3Dboolean_array( (boolean[][][])field[i].get(object));
 
          //byte arrays 
          else if (type.equals("[B"))
             send_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             send_2Dbyte_array( (byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             send_3Dbyte_array( (byte[][][])field[i].get(object));
 
          // character arrays
          else if (type.equals("[C"))
             send_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             send_2Dchar_array( (char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             send_3Dchar_array( (char[][][])field[i].get(object)); 
 
          //short  arrays 
           else if (type.equals("[S"))
             send_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             send_2Dshort_array( (short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             send_3Dshort_array( (short[][][])field[i].get(object)); 
          
          //int  arrays 
          else if (type.equals("[I"))
             send_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             send_2Dint_array( (int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             send_3Dint_array( (int[][][])field[i].get(object)); 
         
          //long  arrays 
          else if (type.equals("[L"))
             send_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[L"))
             send_2Dlong_array( (long[][])field[i].get(object));
          else if (type.equals("[[[L"))
             send_3Dlong_array( (long[][][])field[i].get(object));  
        
          //float   arrays 
          else if (type.equals("[F"))
             send_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             send_2Dfloat_array( (float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             send_3Dfloat_array( (float[][][])field[i].get(object)); 
          
          //double  arrays 
          else if (type.equals("[D"))
             send_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             send_2Ddouble_array( (double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             send_3Ddouble_array( (double[][][])field[i].get(object)); 
          else if(field[i].getDeclaringClass().isInstance(object)) 
             send_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

       }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}
