
package webflow.frontend;

import java.lang.*;
import java.util.*;
import uci.graphedit.*;
import webflow.backend.ID;

/** 
*
* Action
*  |
*  +----------------+
*                   |
*                   ActionCreateNode
*                               |
*                               +
*		  ActionCreateWebNode
* ______________________________________________________________________
*   
*      This is a factory for WebNodes. It create a WebNode on demand.
*/
public class 
ActionCreateWebNode extends ActionCreateNode 
                    implements UserInterfaceDebug
{

  /** A private member that stores the info about the module to be created*/
  ModuleTreeItem module;

  /** 
  * Constructs a new Action with the given:
  *  - class of the graphical representation  for the WebNode;
  *  - Perspective;
  *  - boolean for the global sticky mode;
  *  - data about the module to be created;
  */
  public 
  ActionCreateWebNode(String node, String model, boolean sticky, 
                      ModuleTreeItem _module) 
  {
    /** calls the constructor of the supper class */
    super(node, model, sticky);

    /** set the info about the module */
    module = _module;      

  }// end of constructor

  /** 
  * Executes the action create WebNode
  * We have to overwrite it to do what we want to do.
  * First we set the Global ModuleTree.currentItem variable
  * so that WebNode? objects can set their "module" info
  * in the initialize() method.
  */
  public void 
  doIt(java.awt.Event e)
  {
    if(DEBUG == true) 
       System.out.println(" In doIt of ActionCreateWebNode");

    ModuleTree.currentItem = module;

    /** calls the doIt() method of the supper class */
    super.doIt(e);  

    System.out.println(Globals.mode().instructions());

    if(DEBUG == true) 
       System.out.println(" After doIt of ActionCreateWebNode");

  }// end of doIt()
  

} // end class ActionCreateWebNode 

