
package webflow.frontend;

import java.lang.*;
import java.util.*;
import uci.graphedit.*;
import webflow.backend.*;
import webflow.frontend.WFtree.*;


/** 
* 
*  Action
*   |
*   +----------------+
*                    |
*	       ActionRefreshModuleTree
*  ______________________________________________________________________
*    
*  Destroys all the created modules.
*       
*
* @date Novermber 2, 1997 (Updated November 2, 1997)
* @author H. Timucin Ozdemir
*
*/
public class 
ActionRefreshModuleTree extends Action 
{

    ModuleTree myTree = null;

    PaletteScrollTreeView myPalette = null;

    /** 
    * Constructs an action RefreshModuleTree  
    */
    public 
    ActionRefreshModuleTree(ModuleTree mt, PaletteScrollTreeView palette)
    {
         myTree = mt;
      myPalette = palette;

    }// end of constructor
 
    /** 
    * executes the action RefreshModuleTree 
    */
    public void 
    doIt(java.awt.Event e) 
    {
      
       /** Refreshes the Module Tree */
       myTree.load();
       System.out.println("myTree is refreshed ");

       /** Refreshes the PaletteModuleTreeView */
       myPalette.refresh( new ModuleTreeNode((ModuleTreeItem)myTree.getItems().firstElement()) );
       System.out.println("myPalette is refreshed ");

    }// end of doIt()

    public void 
    undoIt() 
    {
      System.out.println("undo is not implemented");

    }// end of undoIt()

}/* end class ActionRefreshModuleTree */





