
package webflow.frontend.WFtree;

import uci.graphedit.*;
import java.util.*;
import java.awt.*;
import webflow.frontend.*;

/**
*
*/
public class
PaletteScrollTreeView extends Palette
                      implements UserInterfaceDebug
{

   /** */
   private ModuleTree myMtree = null;

   /** */
   private TreeNode root = null;

   /** */
   private int width  = 400;

   /** */
   private int height = 300;
 
   /** */
   ActiveScrollTree myScrollTreePanel = null;

   ActiveButton ab = null;

   /** */
   Frame myFrame = null;

   /** */
   WebEditor myEditor;

   /** */
   public
   PaletteScrollTreeView(WebEditor _myEditor, TreeNode _root, int _width, int _height, Frame _myFrame)
   {  
      super(1,1,"Scrolller");
      myEditor = _myEditor;
      root = _root;
      width = _width;
      height = _height;
      myFrame = _myFrame;

   }// end of constructor

   /** */
   public
   PaletteScrollTreeView(WebEditor _myEditor, ModuleTree mt, int _width, int _height, Frame _myFrame)
   {  
      super(1,1,"Scrolller");
      myEditor = _myEditor;
      myMtree = mt;
      root = new ModuleTreeNode((ModuleTreeItem)myMtree.getItems().firstElement());
      width = _width;
      height = _height;
      myFrame = _myFrame;

   }// end of constructor

   /** */
   public void
   setFrame(Frame _myFrame)
   {  
      if(_myFrame!=null) myFrame = _myFrame; 

   }// end of setFrame()

   /** */
   public Vector
   defineButtons()
   { 
      Vector ret = new Vector();

      myScrollTreePanel = new ActiveScrollTree(root,width,height,myFrame);

      ret.addElement(myScrollTreePanel);

      Action refresh = new ActionRefreshModuleTree(myMtree,this);

      ab = new ActiveButton("Refresh Modules", refresh);
      (ab.component()).resize(400,20);

      ret.addElement(ab);

      return ret;

   }// end of defineButtons()

   /** */
   public void 
   definePanel() 
   {
      rows (Math.max(rows(), height));
      setLayout(null);

      myScrollTreePanel.component().reshape(0,0,width,height);
  
      ab.component().reshape(0,height,width,20);

      add(myScrollTreePanel.component()); 
      add(ab.component()); 

      setFont(new Font("Helvetica", Font.PLAIN, 10));

  }// end of definePanel()



   /**
   * Look at the component's preferredSize if the component exits.
   * If not then use the user's choice.
   */
   public Dimension
   preferredSize()
   { return minimumSize(); }

   /**
   * Minimum Size should not be smaller than the user's choice.
   */
   public Dimension
   minimumSize()
   { return new Dimension(width+10,height+30); }

   /**
   */
   public void
   refresh(TreeNode _root)
   { 
       // root = _root
       root = new ModuleTreeNode((ModuleTreeItem)myMtree.getItems().firstElement());
       myScrollTreePanel.refresh(root);
       myEditor.refresh();

   }// end of refresh()

}// end of PaletteScrollTreeView
