
package webflow.frontend;

import java.util.*;
import java.awt.*;
import uci.graphedit.*;
import webflow.backend.*;


/**
*/
public class 
WebNode extends NetNode 
        implements UserInterfaceDebug
{

  /** */
  protected String name;

  /** */
  protected String server;

  /** */
  protected String depictClass;

  /** */
  protected ID myID; 

  /** */
  protected ModuleTreeItem mli;

  /**
  */
  public void 
  setName( String n)
  {
    name = new String( n );
  }// end of setName()

  /**
  */
  public void 
  setServer( String s)
  {
    server = new String( s );
  }// end of setServer()

  /**
  */
  public void setDepictClass( String cl)
  {
    depictClass = new String( cl );
  }// end of setDepictClass()

  /**
  */
  public void 
  setModuleTreeItem(ModuleTreeItem mli) 
  {
    this.mli = mli; 
  }// end of setModuleTreeItem()

  /**
  */
  public String 
  getName()
  { return name; }

  /**
  */
  public ID 
  getID()
  { return myID; }

  /**
  */
  public String 
  getServer()
  { return server;}

  /**
  */
  public String 
  getDepictClass()
  { return depictClass; }

  /**
  */
  public ModuleTreeItem 
  getModuleTreeItem() 
  { return mli; }

  /**
  *
  */
  public void 
  initModule( ModuleTreeItem m, ID moduleID, Vector portIDs)
  {
    name = new String( m.getClassName() );
    server = new String( m.getServer());
    depictClass = new String( m.getModuleDescClass() );
    myID = moduleID;
    mli = m;

    Enumeration e = portIDs.elements();
    for(int i=0;i < numPorts;i++)
    {
      WebPort wp = (WebPort)portList[i];
      wp.setID( ((ID)e.nextElement()) );

    }// end of for
    
  }// end of initModule()

  /**
  *
  */
  public void 
  editNode()
  {

    if( DEBUG == true )
        System.out.println(" editNode() of WeBNode ");

    ModuleData text = new ModuleData();
    text.append("Name:  "+name+"\n");
    text.append("Server:  "+server+"\n");

    for(int i=0;i < numPorts;i++)
    {
      WebPort wp = (WebPort)portList[i];
      text.append("Port-"+ i +": "+wp.getType()+"\n");

    }// end of for
 
    text.pack();
    text.show();
     
  }// editNode()

  /**
  * This mthod is being called after you placed the object 
  * in the editor. So that you need to initialize the module
  * through WebEditor object. Then you need to open a window
  * for this module on the client screen if the module is
  * viewer module, i.e. has a visible interface to user.
  * To accomplish this, you need to go through WebFlowEditor
  * Applet object because it is the only object who has power
  * to open another netscape window so far.
  */
  public void 
  postPlacement(Editor ed) 
  {   
      ModuleTree.currentItem = mli;

      WebEditor wed = (WebEditor)ed;

      SMreply reply = wed.requestInit(mli);

      if(DEBUG==true)
         System.out.println("postPlacement START for module " + mli.getClassName());

      if(reply != null) 
      {
	     if(DEBUG==true) 
             System.out.println("SMreply status = " + reply.getStatus());

	     if(reply.getStatus() == SMreply.OK) 
         {  initModule(mli, reply.getModuleID(), reply.getPortList()); } 
         else if(reply.getStatus() == SMreply.HTML) 
              {  
                 initModule(mli, reply.getModuleID(), reply.getPortList());
	             int key = reply.getHtmlKey();

	             if(DEBUG==true) System.out.println("HtmlKey = " + key);

                 /** Ask webEditor to open a window for this module */
                 String wName = reply.getViewerWinName();
                 if(wName!=null) wName+=reply.getModuleID();
	             wed.newViewer( key, wName );

	          }
	     else {
                if(DEBUG==true)
	              System.out.println("Invalid SMreply status = " + reply.getStatus());
	          }

      } else { if(DEBUG==true) System.out.println("SMreply = null"); }

      if(DEBUG==true) System.out.println("postPlacement END ");

  }// end of postPlacement()

  /**
  *
  */
  public void
  dispose()
  {  if(DEBUG==true) 
        System.out.println(" I am in dispose ");
     super.dispose();
  }// end of dispose()
	   
}// end of Class WebNode
