
package webflow.frontend;


import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/**
*/
public class 
WebNode2 extends WebNode 
{

  /**
  * Overwrite
  */
  public void 
  initialize(NetNode deft, Object model) 
  {
     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */     
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);

     portList = new WebPort[4];
     numPorts = 4;
     portList[0] = new WebPort(this, "int");
     portList[1] = new WebPort(this, "int");
     portList[2] = new WebPort(this, "int");
     portList[3] = new WebPort(this, "int");

  }// end of initialize() 

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay) 
  {
      Fig obj11 = new FigRect(-35, -35, 50, 70,Color.lightGray, null);
      Fig obj1 = new FigCircle(-25, -25, 30, 50, Color.cyan, Color.lightGray);
      Fig obj2 = new FigCircle(-20, -20, 20, 40,Color.cyan, Color.white);
      FigList temp_list = new FigList();
      temp_list.addFig(obj11);	
      temp_list.addFig(obj1);
      temp_list.addFig(obj2);

      Fig obj3 = new FigArc1( -30, -22, 20, 20, Color.black, Color.red, 135, 80);
      Fig obj4 = new FigArc1( -30, 0, 20, 20, Color.black, Color.blue, 145, 80);	
      Fig obj5 = new FigArc1(-5,  -10, 20, 20, Color.black, Color.orange, -40, 80);
      Fig obj6 = new FigArc1( -20,  -28, 20, 20, Color.black, Color.black, 50, 80);
 

      temp_list.addFig(obj3);
      temp_list.addFig(obj4);
      temp_list.addFig(obj5);
      temp_list.addFig(obj6);
 

      WebPerspective pers1 = new WebPerspective(this, temp_list);

      pers1.addPort(portList[0], obj3, 2);
      pers1.addPort(portList[1], obj4, 2);
      pers1.addPort(portList[2], obj5, 4);
      pers1.addPort(portList[3], obj6, 1);

      return pers1;
  
   }// end of makePerspective()

}// end of class WebNode2 


