package webflow.frontend;


import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/** An example subclass of NetNode for use in the Example application.
*
* @see Example 
*/
public class 
WebNode3 extends WebNode 
{

  /** 
  * Initialize a new WebNode from the given default node and
  * application specific model. <p>
  */
  public void 
  initialize(NetNode deft, Object model) 
  {
     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);

     portList = new WebPort[3];
     numPorts = 3;
     portList[0] = new WebPort(this, "int");
     portList[1] = new WebPort(this, "int");
     portList[2] = new WebPort(this, "int");

  }// end of initialize()
 

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay) 
  {
      Fig obj1 = new FigRect(-30, -30, 70, 60, Color.lightGray, null);
      Fig obj2 = new FigCircle(-20, -20, 50, 50, Color.red,Color.white );
      FigList temp_list = new FigList();

      temp_list.addFig(obj1);
      temp_list.addFig(obj2);
      Fig obj3 = new FigCircle( -15, -20, 15, 15, Color.black, Color.blue);
      Fig obj4 = new FigCircle( 15,  -20, 15, 15, Color.black, Color.orange);
      Fig obj5 = new FigCircle(0,  24, 15, 15, Color.black, Color.green);
 

      temp_list.addFig(obj3);
      temp_list.addFig(obj4);
      temp_list.addFig(obj5);
 

      WebPerspective pers1 = new WebPerspective(this, temp_list);

      pers1.addPort(portList[0], obj3,1);
      pers1.addPort(portList[1], obj4,1);
      pers1.addPort(portList[2], obj5,3);

      return pers1;

   }// end of makePerspective()


}// end class WebNode3 
