
package webflow.frontend;


import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/** 
* An example subclass of NetNode for use in the Example application.
*/
public class 
WebNodeWBClient extends WebNode 
{


  public void 
  initialize(NetNode deft, Object model) 
  {
     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);

     portList = new WebPort[1];
     numPorts = 1;
     portList[0] = new WebPort(this, "img");

  }// end of initialize()
    

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay) 
  {

      int FontSize = 12;
      Font myLabelFont = new Font("TimesRoman",Font.PLAIN,FontSize);
      FontMetrics myLabelFontMetrics = Toolkit.getDefaultToolkit().getFontMetrics(myLabelFont);

      int TextWidth = myLabelFontMetrics.stringWidth(mli.getClassLabel())+5;
      int TextHeight = myLabelFontMetrics.getHeight()+5;

      Fig obj0 = new FigText(-10, -10, TextWidth, TextHeight, Color.white, "TimesRoman", FontSize);
      ((FigText)obj0).setText(mli.getClassLabel());
      Fig obj1 = new FigCircle(-20, -20, TextWidth+20, TextHeight+20, Color.red, Color.black);
      FigList temp_list = new FigList();

      temp_list.addFig(obj1);
      temp_list.addFig(obj0);

      Fig obj3 = new FigArc1(TextWidth/2-20, -25, 20, 20, Color.red, 
			       new Color(240, 80, 255), 50, 80);
    
      temp_list.addFig(obj3);
      

      WebPerspective pers1 = new WebPerspective(this, temp_list);

      pers1.addPort(portList[0], obj3, 1);
   
      return pers1;
 
   }// end of makePerspective()


} /* end class WebNodeImgH.java */
