package webflow.util;

/**
* ListItem is used to implement a List. 
*
*/
public class 
ListItem extends Object
{
  /** Object stored in the List item */
  Object obj;

  /** successor of the List item     */
  ListItem successor = null;

  /** predecessor of the List item     */
  ListItem predecessor = null;

  /**
  * Creates a queue item that will store a given object. 
  * @param _obj the object stored
  */
  public 
  ListItem(Object _obj) 
  {
    if(obj == null) System.out.println(" ListItem : ");
    obj = _obj;
    successor = null;

  }// end of constructor

  /**
  * Returns the object stored in the list item
  * @return the object 
  */
  public Object getObject() 
  {
    return obj;
  }// end of getObject()

  /**
  * Sets the successor of the list item
  * @param next the successor
  */
  public void 
  setSuccessor(ListItem _successor) 
  {
    successor = _successor;
  }// end of setSuccessor()

  /**
  * Returns the successor of the list item
  * @return the successor
  */
  public ListItem 
  getSuccessor() 
  {
    return successor;
  }// end of getSuccessor()

  /**
  * Sets the predecessor of the list item
  * @param next the successor
  */
  public void 
  setPredecessor(ListItem _predecessor) 
  {
    predecessor = _predecessor;
  }// end of setPredecessor()

  /**
  * Returns the predecessor of the list item
  * @param next the successor
  */
  public ListItem 
  getPredecessor() 
  { return predecessor ;
  }// end of getPredecessor()

}// end of ListItem
