
package webflow.util.ModuleEventRouter;

/**
* This object lives with the ModuleManager.
* Modules do not know where their EventQueue is.
* They only publish their events through the EventRouter
* object.
*
* Initialization of each Module, we might want to send the 
* EventRouter object or ID of the EventRouter object which
* sits in the ModuleManager.
* Definetely, we need a message which can be sent to ModuleManager
* and allow us to invoke a method of the Module with the 
* parameters on the ModuleManager side.
*
*/
public class
EventRouter extends Object
{

  /** */
  Hashtable EventQueues = null;
 
  /** */

  /**
  */
  public 
  EventRouter()
  {
     EventQueues = new Hashtable();

  }// end of constructor

  /**
  */
  public synchronized boolean 
  definePublisher(ID moduleID)
  {
    
    boolean retValue = null;

    if( EventQueues.containsKey(moduleID) == false )
    {
       WFEventQueueMonitor newMonitor = new WFEventQueueMonitor();

       retValue = true;

       EventQueues.put( moduleID, newMonitor );

    }// end of if

    return retValue;

  }// end of definePublisher()

  /**
  */
  public synchronized int
  subscriber(ID customer, ID eventSource)
  {
     boolean retValue = false;

     if( EventQueues.containsKey(moduleID) == true )
     {
        WFEventQueueMonitor myMonitor = 
                            (WFEventQueueMonitor) EventQueues.get(eventSource);
        
        if( myMonitor != null )
        {
            myMonitor.addListener( new ModuleEventListener(customer) );

            retValue = true;

        }// end of if

     }// end of if

     return retValue;

  } // end of subscriber()

  /**
  */
  public synchronized boolean
  publish(ID eventSource, ModuleEvent evt)
  {
     boolean retValue = false;

     if( EventQueues.containsKey(moduleID) == true )
     {
        WFEventQueueMonitor myMonitor = 
                            (WFEventQueueMonitor) EventQueues.get(eventSource);
        
        if( myMonitor != null )
        {
           myMonitor.getEventQueue().postEvent(evt);

           retValue = true;

        }// end of if
 
     }// end of if

  } // end of publish()

}// end of class EventRouter
