
/*
 * @(#)ChatServer.java	1.11 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
package webflow.modules.demo.collab;

import webflow.backend.*;
import webflow.frontend.*;
import SharedData.*;
import SharedData.socket.*;
import java.net.*;
import java.io.*;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

public class
ChatServer1 implements ChatDebugFlags,Module{
    
    private static Stringobj sessionName;
    
Naming nm;

ChatPort chatport1;
ChatPort chatport2;
ChatClient client;

//Stringobj clientNames;
//Stringobj clientNamest;

SharedData.Session    chatSession ; 
    public MetaModule initialize(){

	 MetaModule mm=new MetaModule("ChatUser");
         chatport2=new ChatPort();
 mm.putPortID(chatport2.getPortID());
chatport1=new ChatPort();
 
         mm.putPortID(chatport1.getPortID());
       
        return(mm);
    }

    public void run() {
 client      = null;
    chatSession = null;
	String     url         = null;
	String     sessionType = null;
	String     hostname    = null;
	int        hostport    = 0;
 try{
  InetAddress local = java.net.InetAddress.getLocalHost();
   hostname = local.getHostName();
 }
   catch(IOException e){}
        if (ChatServer_Debug) {
            System.out.println("ChatServer: main.");
        }
	sessionName=new Stringobj(2);
	sessionName.setstr("ChatSession",0);
	//sessionName.setstr("WBSession",1);
        
	hostport    = 8100;//getPort(args);
	sessionType = "socket";//getType(args);
	url = "coll://" + hostname + ":" + hostport + "/" + sessionType +
	      "/Session/" + sessionName.getstr(0);

	try {

/* Create a session, [re]bind it and create a channel. */
 
	    chatSession = SessionFactory.createSession(url);
            //clientNames=new Stringobj(chatSession.listClientNames()); 
 System.out.println("Setup and bound Chat server.");
            chatSession.createChannel("ChatChannel", true);	
    //        channelnames=new Stringobj(chatSession.listChannelNames());
//             chatport1.send(sessionName);
	//     chatport2.send(sessionName);
		boolean bool=true;
              //chatport1.send(channelnames);
              //chatport2.send(channelnames);
     	   /* while(true){
		clientNamest=new Stringobj(chatSession.listClientNames());
		if(clientNamest.getlen()!=clientNames.getlen()){
			bool=false;
		}
		else{
			int len=clientNames.getlen();
			for(int i=0;i<len;i++)
				if(clientNames.getstr(i)!=clientNamest.getstr(i))	
					bool=false;
		}
		if(!bool){
			chatport1.send(clientNames);
			chatport2.send(clientNames);
			bool=true;
		}
	}	*/

        } catch (SharedDataException e) {
            System.out.println("Done.. ");
            if (ChatServer_Debug) {
		e.printStackTrace();
	    }
        } 
}        
    




 
   public void destroy(){
     System.out.println("inside chatserver1's destroy method...");
     String url = null;
     String     sessionType = null;
     String     hostname    = null;
     int        hostport    = 0;


      try{
  InetAddress local = java.net.InetAddress.getLocalHost();
   hostname = local.getHostName();
          }
   catch(IOException e){}

   hostport=8100;
   sessionType = "socket";

    url = "coll://" + hostname + ":" + hostport + "/" + sessionType+"/Session/"+"ChatSession";

    
     
     chatport1.destroyPort();
     chatport2.destroyPort();
     // to delete the current open session
     try {
     SessionFactory.deleteSession(url);
         } catch(SharedDataException e) {};
	
     }   
   private static String
    getHost(String args[]) {
        String defHost = "stard";   /* Default host name for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getHost.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-server")) {
                if (++i < length) {
                    return(args[i]);
                }
            }
        }
        return(defHost);
    }

public void stop()
{} 

    private static int
    getPort(String args[]) {
        int defPort = 4461;   /* Default port number for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getPort.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-port")) {
                if (++i < length) {
                    return(Integer.parseInt(args[i]));
                }
            }    
        }
        return(defPort);
    }


    private static String
    getType(String args[]) {
        String defType = "socket";   /* Default Session type. */
        int length = args.length;
        if (ChatServer_Debug) {
            System.out.println("ChatServer: getType.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-type")) {
                if (++i < length) {
                    return(args[i]);
                }
            }    
        }
        return(defType);
    }
}





