

/*
 * @(#)WhiteBoardObserver.java	1.4 97/01/08
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package webflow.modules.demo.collab;

import SharedData.*;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on WhiteBoard; a test applet for the game server from
 * daniel@vpro.nl. It's been rewritten to use the Java Shared Data API,
 * and to make it easier to modify and maintain.
 *
 * @version     0.84 17 October 1996
 * @author      daniel@vpro.nl
 * @author      Rich Burridge
 */

public class
WhiteBoardObserver implements SessionObserver, WhiteBoardDebugFlags {

    /** The name of this session observer. */
    private String name;

    /** The "Server" client joining to the whiteboard session. */
    private Client client;
    
      int bool;

    public
    WhiteBoardObserver(Client client, String name) {
        if (WhiteBoardObserver_Debug) {
            System.out.println("WhiteBoardObserver: constructor: " +
                               " name: " + name);
        }
//   bool=1;
        this.client = client;
	this.name   = name;
    }
 
 
    public String
    getName() {
        if (WhiteBoardObserver_Debug) {
            System.out.println("WhiteBoardObserver: getName: " +
                               " name: " + name);
        }
        return(name);
    }


    public void
    sessionChanged(SessionEvent event) {
     
        String  clientName = event.getClientName();
        Session session    = event.getSession();
        int     type       = event.getType();
        if (WhiteBoardObserver_Debug) {
            System.out.println("WhiteBoardObserver: sessionChanged:" +
                               " session event " + event +
                               " session "       + session +
                               " client name "   + clientName);
	}

/* If there are no clients joined to the server apart from the "Server"
 * client itself, then clean up and terminate.
 */
        if (type == SharedDataEvent.LEAVE) {
	    try {
		String clientNames[] = session.listClientNames();

	        if (clientNames.length == 1&& clientNames[0].equals(client.getName())) {
		    System.out.println("Terminating session."+bool);
		    session.leave(client);
                    //System.exit(0);
                    
	        }
	    } catch (Exception e) {
                if (WhiteBoardObserver_Debug) {
                    e.printStackTrace();
                }
	    }
        }
    }
}
