/*
 * @(#)WhiteBoardUser.java	1.8 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package webflow.modules.demo.collab;

import SharedData.*;
import java.awt.*;
import java.util.*;
import java.applet.Applet;
import java.io.*;
import webflow.*;
import java.net.*;
/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on WhiteBoard; a test applet for the game server from
 * daniel@vpro.nl. It's been rewritten to use the Java Shared Data API,
 * and to make it easier to modify and maintain.
 *
 * @version     0.92 27 February 1997
 * @author      daniel@vpro.nl
 * @author      Rich Burridge
 */

public class
WhiteBoardUserA extends Frame implements Runnable, WhiteBoardDebugFlags {

    /** The name of this User. */
    protected String name;

    /** The unique number associated with this client. */
    public int clientNo;
   static int x=1;
    /** The whiteboard session that this client application will join. */
    private Session session;
DataSocketW s;
    /** The client that will be joining the session and channel. */
    private WhiteBoardClient client;
private WBApp applet;
Panel can;
    /** The array of client names that are currently joined to this session. */
    private String clientNames[];

    /** The channel that this client application will use to send data. */
    private Channel channel;

    /** The consumer of all data sent over the channel. */
    private WBConsumer wbConsumer;

    /** The data that will be sent over the channel. */
    private Data data;

    /** Indicates if the client is successfully connected to the server. */
    boolean connected = false;

    /** The white board drawing area. */
    DrawingArea drawingArea;

    /** The white board menu controls. */
    Controls controls;

/* Default setup, will mostly be overriden by attributes. */

    int     width       = 600;
    int     height      = 250;
    String  hostname    = "NULL";
    int     hostport    = 8102; 
    String  sessionType = "socket";
  MediaTracker tracker = new MediaTracker(this); 
    private Thread running = null;

/* XXX: See if these can be moved to the Controls and DrawingArea classes and
 *      made private.
 */

    public String commandLine  = null;
    public Image  brushes[]    = new Image[10];

    public int     pointx1     = 0;
    public int     pointx2     = 0;
    public int     pointy1     = 0;
    public int     pointy2     = 0;
    public int     coll_offset = 0;
    public int     bs_offset   = 0;
    public boolean textmode    = false;
    public String  textline    = "";
    public int     drawtype    = 0;
    public Image   bs[]        = new Image[40];

Frame frame;

/*  Read all the needed attributes and get the needed data.
 *  It starts 5 threads to download the needed pictures at the same time.
 */

public WhiteBoardUserA(String host,int port,WBApp app){
s=new DataSocketW(host,port,this);
applet=app;

}
    public synchronized void
    init() {
        int i;

        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: init.");
        }
 
/* Get needed attributes from the html page. */

/*        if (getParameter("width") != null) {
            width = Integer.parseInt(getParameter("width"));
        } else {
            width = 600;
        }

	if (getParameter("height") != null) {
	    height = Integer.parseInt(getParameter("height"));
        } else {
	    height = 250;
        }

	if (getParameter("server") != null) {
	    hostname = getParameter("server");
	}

	if (getParameter("port") != null) {
            hostport = Integer.parseInt(getParameter("port"));
	} 

        if (getParameter("type") != null) {
            sessionType = getParameter("type");
        }*/
/* Get the needed brush pictures. */
        
        getImages(0,  8, "black");
        getImages(8,  8, "red");
        getImages(16, 8, "green");
        getImages(24, 8, "blue");
        getImages(32, 8, "yellow");
System.out.println("EROOORRR");
can=new Panel();
resize(width,height);	
add(can);
 can.setLayout(new BorderLayout());
        drawingArea = new DrawingArea(width, height - 80, this);
        can.add("North", drawingArea);
        controls = new Controls(width, 80, this);
        can.add("South", controls);
can.resize(width,height);
//     frame=new Frame();
//frame.setTitle("WhiteBoard User");
//frame.add(this);        
  //      frame.pack();
    //    frame.resize(width, height);
      //  frame.show();
     
    }


    private void
    getImages(int position, int count, String name) {
        int i;
    //    MediaTracker tracker = new MediaTracker(this); 
 
/*        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: getImage: " + name);
        }
 
        for (i = 0; i < count; i++) {
            bs[position+i] = getImage(getCodeBase(), "images/" + name + (i+1)); 
            tracker.addImage(bs[position+i], i); 
        }
 
        if (WhiteBoardUser_Debug) {
	    System.out.println("Waiting for images to be loaded.");
        }
	try { 
            tracker.waitForAll();
        } catch (InterruptedException e) { } */
applet.getImages(position,count,name);  
    }


    public boolean
    handleEvent(Event event) {
        switch (event.id) {
	    case Event.WINDOW_DESTROY:
		System.out.println("Client terminating.");
		try {
		    session.leave(client);
		} catch (Exception e) {
                    System.out.println("WhiteBoardUser: handleEvent: " +
                                       "exception " + e);
                    if (WhiteBoardUser_Debug) {
                        e.printStackTrace();
                    }
		}
		System.exit(0);
		return(true);
	    default:
		return(false);
        }
    }


/* Generate a random number between low and high. */

    private int
    rrange(int low, int high) {
        return((int)(Math.random() * (high - low + 1) + low));
    }


    private boolean
    isConnected() {
        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: isConnected: " + connected);
        }

	return(connected);
    }


    public void
    writeLine(String line) {
        String message = clientNo + " " + line;
	int size = message.length();
        byte[] theData = new byte[size];

        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: writeLine: " + message);
        }

	if (isConnected()) {
            message.getBytes(0, size, theData, 0);
            try {
                data = new Data(theData);
                data.setPriority(Channel.HIGH_PRIORITY);
                channel.sendToAll(client, data);
            } catch (Exception e) {
                System.out.print("Caught exception in ");
                System.out.println("WhiteBoardUser.writeLine(): " + e);
                e.printStackTrace();
            }
	}
    }


    private boolean
    connect() {
	if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: connect.");
        }

        try {
	    String sessionName = "WBSession";

/* Create a whiteboard client. */

            System.out.println("Creating a WhiteBoard Client...");
	    client = new WhiteBoardClient(name);

/* Resolve the whiteboard session. */
               
	    try {
                String url = "coll://" + hostname + ":" + hostport +
                             "/" + sessionType + "/Session/" + sessionName;
                System.out.println("here 2");
                session = SessionFactory.createSession(url);

/*  Join the session, and a named channel; set the channels data consumer. */
                System.out.println("Client Session created");
                session.join(client);
System.out.println("WB client has joined the session..");                 
/*  Need to setup a unique number for this client. A simple cheap way is to
 *  determine how many clients are joined to the session, and use that.
 */
        
		clientNames = session.listClientNames();
		clientNo    = clientNames.length;
                System.out.println("5555555555");
                channel = Channel.join(session, "WBChannel", client);
System.out.println("Client joined to Whiteboard Channel");
                wbConsumer = new WBConsumer(client.getName(), this);
//System.out.println("77777777777777777");         
       channel.setConsumer(client, wbConsumer);
       System.out.println("Consumer for this client created...");
            } catch (Exception e) {
		System.out.println("Leaving..");
                e.printStackTrace();
		return(false);
            }
        } catch (Throwable th) {
            System.err.println("WhiteBoardUser: connect caught: " + th);
            th.printStackTrace();
            throw new Error("WhiteBoardUser: connect: failed : " + th);
        }
	return(true);
    }


    private void
    disconnect() {
	try {
	    if (WhiteBoardUser_Debug) {
		System.out.println("WhiteBoardUser: disconnect.");
	    }
/* Leave the channel and leave the session. */

	    channel.leave(client);
	    session.leave(client);
	} catch (Exception e) {
	    System.err.print("Caught exception while trying to ");
	    System.err.println("disconnect from whiteboard server: " + e);
            e.printStackTrace();
	}
    }


    public void
    start() {
        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: start.");
        }

        if (running == null) {
            running = new Thread(this);
            running.start();
        }
    }


    public void
    stop() {
        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: stop.");
        }

	if (running != null) {
	    running.stop();
	    running = null;
	}
    }


    public void
    run() {
        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: run.");
        }

//	name = System.getProperty("user.name") + ":" +(rrange(0, 1000) *rrange(0, 1000));

         
    }

public void wb_connect(Socket socket){
    System.out.println("just entered wb_connect in whiteboardusera...");
	name = String.valueOf(WhiteBoardUserA.x)+ ":" +  (rrange(0, 1000)* rrange(0, 1000));
 System.out.println("name"+name);     
   WhiteBoardUserA.x+=1;
     System.out.println("just about to call connect method in wbua..");
   	connected = connect();
    System.out.println("just after call to connect method in wbua..");
    }

    public void
    destroy() {
        if (WhiteBoardUser_Debug) {
            System.out.println("WhiteBoardUser: destroy.");
        }

        running = null;
        disconnect();
dispose();
    }


    public boolean
    handleKey(int key) {
	String colorline;

        if (WhiteBoardUser_Debug) {

            System.out.println("WhiteBoardUser: keyDown: " + key);
        }
System.out.println("Okay Entering text mode");
	if (textmode == true) {
	    if ((char) key == 8) {
		textline = textline.substring(0, textline.length() - 1);
	    }
	    else if ((char) key != '\n') {
		Character t = new Character((char) key);

		textline = textline + t.toString();
	    } else {
		textline = textline.replace(' ', '|');
		colorline = "BLACK";
		if (coll_offset == 0*8) {
		    colorline = "BLACK";
		} else if (coll_offset == 1*8) {
		    colorline = "RED";
		} else if (coll_offset == 2*8) {
		    colorline = "GREEN";
		} else if (coll_offset == 3*8) {
		    colorline = "BLUE";
		} else if (coll_offset == 4*8) {
		    colorline = "YELLOW";
		}
		writeLine("TEXT " + colorline + " " + textline + " " +
                          pointx1 + " " + pointy1 + "\n");
		textline = "";
		pointx1 = 0;
		textmode = false;
	    }
	}

        controls.repaint();
        drawingArea.repaint();
	return(true);
    }
}


class
DrawingArea extends Panel implements WhiteBoardDebugFlags {

    /** The WhiteBoardUser for this menu canvas. */
    WhiteBoardUserA wbu;

    /** Offscreen backing store image of the menu controls. */
    private Image image = null;

    /** The Graphics context for the offscreen image. */
    Graphics gc;

    /** The width of the white board drawing area canvas. */
    private int width;

    /** The height of the white board drawing area canvas. */
    private int height;


    public
    DrawingArea(int width, int height, WhiteBoardUserA client) {
        if (DrawingArea_Debug) {
            System.out.println("DrawingArea: constructor:" +
				" width: "  + width +
				" height: " + height +
				" client: " + client);
        }

        this.width  = width;
        this.height = height;
        wbu         = client;
    }


    public Dimension
    preferredSize() {
        return(new Dimension(width, height));
    }


    public boolean
    handleEvent(Event event) {
        switch (event.id) {
            case Event.MOUSE_DRAG:
                if (DrawingArea_Debug) {
                    System.out.println("DrawingArea: MOUSE DRAG.");
                }
                if (wbu.drawtype == 0) {
                    wbu.writeLine("DOT " + event.x + " " + event.y + "\n");
                }
                break;

            case Event.MOUSE_DOWN:
                if (DrawingArea_Debug) {
                    System.out.println("DrawingArea: MOUSE_DOWN.");
                }
                if (wbu.drawtype == 0) {                        /* DOT. */
                    wbu.writeLine("DOT " + event.x + " " + event.y + "\n");
                } else if (wbu.drawtype == 1) {                 /* LINE. */
                    if (wbu.pointx1 == 0) {
                        wbu.pointx1 = event.x;
                        wbu.pointy1 = event.y;
                    } else {
                        wbu.writeLine("LINE " + wbu.pointx1 + " " +
                                                 wbu.pointy1 + " " +
                                      event.x + " " + event.y + "\n");
                        wbu.pointx1 = 0;
                    }
                } else if (wbu.drawtype == 2) {                 /* TEXT. */
                    if (wbu.pointx1 == 0) {
                        wbu.pointx1   = event.x;
                        wbu.pointy1   = event.y;
                        wbu.textmode  = true;
                        requestFocus();
                    }
                } else if (wbu.drawtype == 3) {                 /* CIRCLE. */
                    if (wbu.pointx1 == 0) {
                        wbu.pointx1 = event.x;
                        wbu.pointy1 = event.y;
                    } else {
                        wbu.writeLine("CIRCLE " + wbu.pointx1 + " " +
                                        wbu.pointy1 + " " +
                                        event.x + " " + event.y + "\n");
                        wbu.pointx1 = 0;
                    }
                }
                break;

            case Event.MOUSE_UP:
                break;

            case Event.KEY_PRESS:
                wbu.handleKey(event.key);
                break;

            default:
                return(false);
        }

        wbu.controls.repaint();
        repaint();
        return(true);
    }


    public synchronized void
    update(Graphics g) {
        Dimension d = size();

        if (DrawingArea_Debug) {
            System.out.println("DrawingArea: update.");
        }

        if ((image == null) || (d.width != width) || (d.height != height)) {
            image = createImage(width, height);
            width = d.width;
            height = d.height;
            gc = image.getGraphics();
            gc.setFont(new Font("Helvetica", Font.PLAIN, 24));
            gc.setColor(Color.white);
            gc.fillRect(0, 0, width, height);
        }
        redraw();
        g.drawImage(image, 0, 0, this);
    }


    public void
    redraw() {
        String drawcommand, tmp;
        int    who, i, j, px1, py1, px2, py2, radius;
        float  k, l, m;
        StringTokenizer tok;
        Image  selectedbrush;

        if (DrawingArea_Debug) {
            System.out.println("DrawingArea: redraw: commandLine is " +
                                wbu.commandLine);
        }

/* Loop for commands, it stays there until no new commands are in the buffer */

        while (wbu.commandLine != null) {
            tok = new StringTokenizer(wbu.commandLine, " ,\n\r\t");
            wbu.commandLine = null;
            who = Integer.parseInt(tok.nextToken());
            drawcommand = tok.nextToken();

            if (drawcommand.equals("BRUSH")) {

/* Brush change found set new drawimage for that whiteboard. */

                wbu.brushes[who] = wbu.bs[Integer.parseInt(tok.nextToken())];
            } else if (drawcommand.equals("DOT")) {

/* Dot found draw dot in correct brush/color on screen. */

                selectedbrush = wbu.brushes[who];
                gc.drawImage(selectedbrush,
                    Integer.parseInt(tok.nextToken()) -
                                     (selectedbrush.getWidth(this) / 2),
                    Integer.parseInt(tok.nextToken()) -
                                     (selectedbrush.getHeight(this) / 2),
                    this);
            } else if (drawcommand.equals("TEXT")) {

/* Line of text found, select color and print it. */

                tmp = tok.nextToken();
                if (tmp.equals("BLACK")) {
                    gc.setColor(Color.black);
                }
                if (tmp.equals("RED")) {
                    gc.setColor(Color.red);
                }
                if (tmp.equals("GREEN")) {
                    gc.setColor(Color.green);
                }
                if (tmp.equals("BLUE")) {
                    gc.setColor(Color.blue);
                }
                if (tmp.equals("YELLOW")) {
                    gc.setColor(Color.yellow);
                }
                gc.drawString(tok.nextToken().replace('|',' '),
                             Integer.parseInt(tok.nextToken()),
                             Integer.parseInt(tok.nextToken()));
            } else if (drawcommand.equals("LINE")) {

/* Line command found, calc the RC and draw the line with the current brush. */

                selectedbrush = wbu.brushes[who];
                px1 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getWidth(this) / 2);
                py1 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getHeight(this) / 2);
                px2 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getWidth(this) / 2);
                py2 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getHeight(this) / 2);
                if (Math.abs(px1 - px2) > Math.abs(py1 - py2)) {
                    k = py1;
                    l = (py2 - py1) / (float) (Math.abs(px2 - px1));
                    j = px1;
                    if (px1 < px2) {
                        i = 1;
                    } else {
                        i = -1;
                    }
                    while (j != px2) {
                        gc.drawImage(selectedbrush, j, (int) k, this);
                        k += l;
                        j += i;
                    }
                } else {
                    k = px1;
                    l = (px2 - px1) / (float) (Math.abs(py2-py1));
                    j = py1;
                    if (py1 < py2) {
                        i = 1;
                    } else {
                        i = -1;
                    }
                    while (j != py2) {
                        gc.drawImage(selectedbrush, (int) k, j, this);
                        k += l;
                        j += i;
                    }
                }
            } else if (drawcommand.equals("CIRCLE")) {

/*  Circle command found, calculate the radius and draw the circle with the
 *  current brush.
 */

                selectedbrush = wbu.brushes[who];
                px1 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getWidth(this) / 2);
                py1 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getHeight(this) / 2);
                px2 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getWidth(this) / 2);
                py2 = Integer.parseInt(tok.nextToken()) -
                                       (selectedbrush.getHeight(this) / 2);

                k = Math.abs(px1 - px2);
                l = Math.abs(py1 - py2);
                radius = (int) Math.sqrt((k * k) + (l * l));
                drawCircle(selectedbrush, px1, py1, radius);
            } else if (drawcommand.equals("CLR")) {

/* Clear screen found, clear the drawing area. */

                gc.setColor(Color.white);
                gc.fillRect(0, 0, width, height);
            }
        }
    }    


    private void
    drawCirclePoints(Image brush, int cx, int cy, int dx, int dy) {
        gc.drawImage(brush, cx + dx, cy + dy, this);
        gc.drawImage(brush, cx - dx, cy + dy, this);
        gc.drawImage(brush, cx + dx, cy - dy, this);
        gc.drawImage(brush, cx - dx, cy - dy, this);
        gc.drawImage(brush, cx + dy, cy + dx, this);
        gc.drawImage(brush, cx - dy, cy + dx, this);
        gc.drawImage(brush, cx + dy, cy - dx, this);
        gc.drawImage(brush, cx - dy, cy - dx, this);
    }


    private void
    drawCircle(Image brush, int cx, int cy, int r) {
        int dx = 0;
        int dy = r;
        int p = 3 - 2*r;

        if (DrawingArea_Debug) {
            System.out.println("DrawingArea: drawCircle: cx: " + cx +
                                "  cy: " + cy + "  radius: " + r);
        }

        while (dx < dy) {
            drawCirclePoints(brush, cx, cy, dx, dy);
            if (p < 0) {
                p = p + 4*dx + 6;
            } else {
                p = p + 4*(dx - dy) + 10;
                dy--;
            }
            dx++;
        }
        if (dx == dy) {
            drawCirclePoints(brush, cx, cy, dx, dy);
        }
    }    


    public void
    paint(Graphics g) {
        if (DrawingArea_Debug) {
            System.out.println("DrawingArea: paint: image is " + image);
        }

        if (image != null) {
            g.drawImage(image, 0, 0, this);
        } else {
            update(g);
        }
    }    
}


class
Controls extends Panel implements WhiteBoardDebugFlags {

    /** The WhiteBoardUser for this menu canvas. */
    private WhiteBoardUserA wbu;

    /** Offscreen backing store image of the menu controls. */
    private Image image = null;

    /** The Graphics context for the offscreen image. */
    Graphics gc;

    /** The width of the menu controls canvas. */
    private int width;

    /** The height of the menu controls canvas. */
    private int height;

    public
    Controls(int width, int height, WhiteBoardUserA client) {
        if (Controls_Debug) {
            System.out.println("Controls: constructor: " + client);
        }

        this.width  = width;
        this.height = height;
        wbu         = client;
    }


    public Dimension
    preferredSize() {
        return(new Dimension(width, height));
    }


    public boolean
    handleEvent(Event event) {
        switch (event.id) {
            case Event.MOUSE_DOWN:
                break;

            case Event.MOUSE_UP:
                if (Controls_Debug) {
                    System.out.println("Controls: MOUSE_DOWN.");
                }
                if (event.y < height-40) {
                    if (event.x > 428 && event.x < 596) {
                        wbu.coll_offset = ((int) (event.x - 428) / 34) * 8;
                        wbu.writeLine("BRUSH " +
                                      (wbu.bs_offset + wbu.coll_offset) + "\n");                        break;
                    }
                    if (event.x > 3 && event.x < 275) {
                        wbu.bs_offset = (int) (event.x-3) / 34;
                        wbu.writeLine("BRUSH " +
                                      (wbu.bs_offset + wbu.coll_offset) + "\n");                        break;
                    }
                } else {
                    if (event.x < 50) {
                        wbu.writeLine("CLR\n");
                    } else if (event.x < 135) {
                        wbu.drawtype = 0;
                    } else if (event.x < 200) {
                        wbu.drawtype = 1;
                    } else if (event.x < 280) {
                        wbu.drawtype = 2;
                    } else if (event.x < 400) {
                        wbu.drawtype = 3;
                    }
                }
                break;

            case Event.KEY_PRESS:
                wbu.handleKey(event.key);
                break;

            default:
                return(false);
        }

        repaint();
        wbu.drawingArea.repaint();
        return(true);
    }


    public synchronized void
    update(Graphics g) {
        Dimension d = size();

        if (Controls_Debug) {
            System.out.println("Controls: update.");
        }

        if ((image == null) || (d.width != width) || (d.height != height)) {
            image = createImage(width, height);
            width = d.width;
            height = d.height;
            gc = image.getGraphics();
            gc.setFont(new Font("Helvetica", Font.PLAIN, 24));
        }
        redraw();
        g.drawImage(image, 0, 0, this);
    }


    public void
    redraw() {
        int i;

        if (Controls_Debug) {
            System.out.println("Controls: redraw.");
        }

/* Paint control bars. */

        gc.setColor(Color.black);
        gc.fillRect(0, height-80, width-1, 39);
        gc.fillRect(0, height-40, width-1, 39);

/* Paint brushes. */

        for (i = 0; i < 8; i++) {
            gc.setColor(Color.white);
            gc.fillRect(3 + (i*34), height-77, 32, 32);
System.out.println("filled rect " + height); 
            gc.drawImage(wbu.bs[i + wbu.coll_offset],
                         3+(i*34), height-77, this);
        }

/* White out area between brushes and color selector. */

        gc.setColor(Color.white);
        gc.fillRect(241, height-77, 184, 32);

/* Create simple color selector. */

        gc.setColor(Color.black);
        gc.fillRect(428, height-77, 32, 32);

        gc.setColor(Color.red);
        gc.fillRect(462, height-77, 32, 32);

        gc.setColor(Color.green);
        gc.fillRect(496, height-77, 32, 32);

        gc.setColor(Color.blue);
        gc.fillRect(530, height-77, 32, 32);

        gc.setColor(Color.yellow);
        gc.fillRect(564, height-77, 32, 32);

        gc.setColor(Color.white);

/* When in text mode draw current text in correct color. */

        if (wbu.textmode == true) {
            if (wbu.coll_offset == 0*8) {
                gc.setColor(Color.white);
            }
            if (wbu.coll_offset == 1*8) {
                gc.setColor(Color.red);
            }
            if (wbu.coll_offset == 2*8) {
                gc.setColor(Color.green);
            }
            if (wbu.coll_offset == 3*8) {
                gc.setColor(Color.blue);
            }
            if (wbu.coll_offset == 4*8) {
                gc.setColor(Color.yellow);
            }
            gc.drawString("TEXT = " + wbu.textline, 10, height-10);
            return;
        }

/* Fill first control bar. */

        gc.drawString("CLR",    10,  height-10);
        gc.drawString("DOT",    71,  height-10);
        gc.drawString("LINE",   139, height-10);
        gc.drawString("TEXT",   206, height-10);
        gc.drawString("CIRCLE", 280, height-10);
        gc.setColor(Color.black);
        gc.drawRect(4 + (wbu.bs_offset*34), height-76, 30, 30);
        gc.setColor(Color.yellow);
        gc.drawRect(3 + (wbu.bs_offset*34), height-77, 32, 32);

/* When something is selected highlight it. */

        if (wbu.drawtype == 0) {
            gc.drawString("DOT", 71, height-10);
        } else if (wbu.drawtype == 1) {
            gc.drawString("LINE", 139, height-10);
        } else if (wbu.drawtype == 2) {
            gc.drawString("TEXT", 206, height-10);
        } else if (wbu.drawtype == 3) {
            gc.drawString("CIRCLE", 280, height-10);
        }
        gc.setColor(Color.black);
    }


    public void
    paint(Graphics g) {
        if (Controls_Debug) {
            System.out.println("Controls: paint: image is " + image);
        }

        if (image != null) {
            g.drawImage(image, 0, 0, this);
        } else {
            update(g);
        }
    }    
}
class
WBConsumer implements ChannelConsumer, WhiteBoardDebugFlags {
 
    /** The name of this channel consumer. */
    protected String name;
 
    /** The WhiteBoardUser for this consumer. */
    WhiteBoardUserA wbu;
 
 
    public
    WBConsumer(String name, WhiteBoardUserA wbUser) {
        if (WBConsumer_Debug) {
            System.out.println("WBConsumer: constructor(" + name + ").");
        }
 
        this.name = name;
        this.wbu  = wbUser;
    }


    public synchronized void
    dataReceived(Data data) {
        byte[] theData = data.getData();

        if (WBConsumer_Debug) {
            System.out.println("WBConsumer: dataReceived: " +
                               " Data " + theData);
        }

/* Handle the data received. */

/* XXX: Possible problem with only a partially given command. */

        wbu.commandLine = new String(theData, 0);
        if (WBConsumer_Debug) {
            System.out.println("Setting commandLine to: " + wbu.commandLine);
        }
        wbu.controls.repaint();
        wbu.drawingArea.repaint();
    }
}
